<template>
	<f7-page name="cctv" @page:beforein="onPageBeforeIn">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="CCTV">
            <f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">{{ user.residential != null ? user.residential.name : 'CCTV' }}</f7-nav-title>
		</f7-navbar>
		<f7-list media-list no-hairlines v-if="!cctvLoading && cctvs.length > 0">
            <f7-list-item
                v-for="(item, index) in cctvs"
                :key="index"
                :link="`/cctv/${item.id}/`"
                :after="currentLocation ? distance(currentLocation.latitude, currentLocation.longitude, item.latitude, item.longitude) : ''"
                :title="item.name"
                :subtitle="item.status.capitalize()"
            >
                <f7-icon slot="media" material="videocam" size="48"></f7-icon>
            </f7-list-item>
            
        </f7-list>
        <f7-block v-else-if="!cctvLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="videocam_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
		<f7-list media-list no-hairlines v-if="cctvLoading">
            <f7-list-item
                v-for="n in 8"
                :key="n"
                class="skeleton-text skeleton-effect-blink"
                title="Lorem ipsum dolor sit amet"
                subtitle="Position"
                after="31 Juli 2019"
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { initial, distance } from '../js/utils';
import { setTimeout } from 'timers';
export default {
	name: 'CCTV',
	data(){
		return{
			cctvLoading: true
		};
	},
	computed: {
		...mapGetters('auth', ['user']),
		...mapGetters('cctv', [
			'cctvs'
		]),
		currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
	},
	methods: {
		initial,
		distance,
		getCCTVS(){
			const self = this;			

			self.$store.dispatch('cctv/getCCTVS', {
                status: 'online',
				residential: self.user.residential ? self.user.residential.id : null,
				exclude: 'author,residential'
			}).then(()=>{
				setTimeout(()=>{
					self.cctvLoading = false;
				}, 100);
			})
		},
		onPageBeforeIn(){
			const self = this;

			self.getCCTVS();
		}
	},
	mounted(){
		const self = this;
		const app = self.$f7;
		const $$ = self.$$;
	}
}
</script>
